<template lang="pug">
.message( :class='[ type, !sended ? "is-danger" : "" ]' )
	.message-body
		.sender {{ username }}
		img( v-if='image' :src='src' )
		.docs.is-flex.is-align-items-flex-start.is-justify-content-flex-end.mt-2( v-if='docs.length' )
			b-file.ml-2( v-for='(file, i) in docs' :key='i' :file='file' type="file" )
		.images.is-flex.is-align-items-flex-start.is-justify-content-flex-end.mt-2.mb-2( v-if='images.length' )
			b-file.ml-2( v-for='(file, i) in images' :key='i' :file='file' )
		.caption( v-if='caption' v-html='content' )
		.file( v-if='file' )
			a.tag.is-link.is-large.is-flex.is-align-items-center.is-justify-content-center( @click='downloadFile' ) 
				span.icon.mr-2
					i.fa-solid.fa-file
				span {{ file.name }}
		.data.is-flex.is-align-items-center.is-justify-content-flex-end
			.time.mr-2 {{ date }}
			template( v-if='sended' )
				span.icon.is-small.has-text-success
					i.fa-solid.fa-check-double
				span.icon.is-small.has-text-info( v-if='edited' )
					i.fa-solid.fa-pen
			template( v-else )
				p.mr-2.has-text-danger( @click='emit("retrySend")' ) Повторить отправку
				span.icon.is-small.has-text-danger
					i.fa-solid.fa-check

iframe.is-hidden( v-if='upload' :src='href' crossorigin="use-credentials" )
</template>

<script setup>
import BFile from "@/components/chat/File.vue"

import { ref, computed } from "vue"
import dayjs from "dayjs"

const props = defineProps({
	type: {
		type: String,
		default: "client",
		valdator: val => [ "client", "user" ].includes(val)
	},
	caption: {
		type: String,
		default: ""
	},
	image: {
		type: String,
		default: ""
	},
	file: {
		type: Object,
		default: () => ({})
	},
	sender: {
		type: Object,
		default: () => ({})
	},
	sended: {
		type: Boolean
	},
	createdAt: {
		type: String
	},
	updatedAt: {
		type: String
	},
	files: {
		type: Array,
		default: () => []
	},
	watched: Boolean,
	edited: Boolean
})
const emit = defineEmits([ "retrySend" ])

const upload = ref(false)

const content = computed(() => props.caption ? props.caption.replace(/\n/, "<br>") : null)
const src = computed(() => `${import.meta.env.VITE_API}/image.jpeg?id=${props.image}`)
const href = computed(() => `${import.meta.env.VITE_API}/file/${props.file?.name}?id=${props.file?.id}&mime_type=${props.file?.mime_type}`)
const username = computed(() => props.sender.fullName || props.sender.username)
const docs = computed(() => props.files.filter(({ bucket }) => bucket == "files"))
const images = computed(() => props.files.filter(({ bucket }) => bucket == "images"))
const date = computed(() => {
	let data = props.createdAt

	if (props.sender.tg_id)
		data = props.updatedAt

	return dayjs(data).format("DD.MM.YY HH:mm")
})

const downloadFile = () => {
	upload.value = true
	setTimeout(() => upload.value = false, 10000)
}
</script>

<style lang="scss" scoped>
.message {
	max-width: 600px;
	background: $success-light;
	box-shadow: 0 .25rem 1rem .25rem rgba($scheme-invert, 0.1);
	position: relative;
	.message-body {
		color: #000;
		padding-right: 1.5rem;
		padding-left: .75rem;
		padding-bottom: 2rem;
		border-color: $success;
	}
	.sender {
		font-weight: bold;
		margin-top: -.75rem;
		margin-bottom: .5rem;
	}
	.caption {
		font-size: 1.125rem;
		:deep(a) {
			color: $link!important;
		}
	}
	&.admin {
		margin-left: auto;
		background: $info-light;
		.message-body {
			text-align: right;
			padding-left: 1.5rem;
			padding-right: .75rem;
			border-width: 0 4px 0 0;
			border-color: $info;
		}
	}
	&.is-danger {
		background: $danger-light;
		.message-body {
			border-color: $danger;
		}
	}

	.data {
		position: absolute;
		bottom: .25rem;
		right: .75rem;
		.time {
			font-size: .75rem;
			font-weight: 600;
			color: $grey;
		}
		p {
			font-size: .75rem;
			font-weight: 600;
			text-decoration: underline;
			cursor: pointer;
			&:hover {
				opacity: .8;
			}
		}
	}
}
</style>